diff --git a/packages/visualgst/StBrowser/GtkCategorizedNamespaceWidget.st b/packages/visualgst/StBrowser/GtkCategorizedNamespaceWidget.st
index 0e57fe6..799ccda 100644
--- a/packages/visualgst/StBrowser/GtkCategorizedNamespaceWidget.st
+++ b/packages/visualgst/StBrowser/GtkCategorizedNamespaceWidget.st
@@ -33,13 +33,12 @@
 |
 ======================================================================"
 
-GtkConcreteWidget subclass: GtkCategorizedNamespaceWidget [
-    | namespaceTree model |
+Compoment subclass: GtkCategorizedNamespaceWidget [
 
     initialize [
         <category: 'initialization'>
 
-        self mainWidget: self buildTreeView.
+        self buildTreeView.
 	self registerNotifier
     ]
 
@@ -55,52 +54,50 @@ GtkConcreteWidget subclass: GtkCategorizedNamespaceWidget [
     buildTreeView [
         <category: 'user interface'>
 
-	namespaceTree := GtkScrollTreeWidget createTreeWithModel: {{GtkColumnPixbufType visible. GtkColumnTextType title: 'Namespaces'}}.
-	namespaceTree connectToWhenPopupMenu: (NamespaceMenus on: self).
-	namespaceTree treeView getSelection setMode: GTK.Gtk gtkSelectionBrowse.
-	(model := GtkTreeModel on: namespaceTree treeView getModel)
-                                        item: FakeNamespace;
-                                        childrenBlock: [ :each | (each subspaces asArray sort: [ :a :b | a name <= b name ]), (each categories values sort: [ :a :b | a name <= b name ]) ];
-                                        contentsBlock: [ :each | {each icon. each name asString} ];
-                                        connectSignal: 'row-has-child-toggled' to: self selector: #'childToggled:path:iter:';
-                                        refresh.
-	^ namespaceTree mainWidget
+	self widget: (Tree 
+                        column: {{GtkColumnPixbufType visible. GtkColumnTextType title: 'Namespaces'}}
+                        children: [ :each | (each subspaces asArray sort: [ :a :b | a name <= b name ])", (each categories values sort: [ :a :b | a name <= b name ])" ]
+                        contents: [ :each | {each icon. each name asString} ]).
+	widget popupMenu: (NamespaceMenus on: self).
+	widget singleSelection.
+        widget item: FakeNamespace.
+        widget refresh.
+	"connectSignal: 'row-has-child-toggled' to: self selector: #'childToggled:path:iter:';"
     ]
 
     whenSelectionChangedSend: aSelector to: anObject [
         <category: 'events'>
 
-        namespaceTree treeView getSelection
-            connectSignal: 'changed' to: anObject selector: aSelector
+        widget whenSelectionChangedSend: aSelector to: anObject
     ]
 
     selectANamespace: aNamespace [
         <category: 'item selection'>
 
 	(self hasSelectedNamespace and: [ self selectedNamespace == aNamespace ]) ifTrue: [ ^ self ].
-	(namespaceTree treeView)
-			    expandAll;
-			    select: aNamespace
+	widget
+	        expandAll;
+		select: aNamespace
     ]
 
     hasSelectedNamespace [
         <category: 'testing'>
 
-        ^ namespaceTree treeView hasSelectedItem
+        ^ widget hasSelection
     ]
 
     selectedNamespace [
         <category: 'accessing'>
 
 	self hasSelectedNamespace ifFalse: [ self error: 'nothing is selected' ].
-	^ namespaceTree treeView selection namespace
+	^ widget selection namespace
     ]
 
     selectedCategory [
         <category: 'accessing'>
 
         self hasSelectedNamespace ifFalse: [ self error: 'nothing is selected' ].
-        ^ namespaceTree treeView selection category
+        ^ widget selection category
     ]
 
     state [
@@ -115,28 +112,28 @@ GtkConcreteWidget subclass: GtkCategorizedNamespaceWidget [
     childToggled: model path: path iter: iter [
 	<category: 'signals'>
 
-	namespaceTree treeView collapseRow: path.
+	"widget treeView collapseRow: path.
 	((model at: iter) at: 3) isNamespace ifTrue: [
 	    ((model at: iter) at: 3) subspaces isEmpty ifFalse: [
-		namespaceTree treeView expandRow: path openAll: false ] ]
+		widget treeView expandRow: path openAll: false ] ]"
     ]
 
     addEvent: anEvent [
         <category: 'model event'>
 
-	model append: anEvent item parent: anEvent item superspace
+	"model append: anEvent item parent: anEvent item superspace"
     ]
 
     removeEvent: anEvent [
         <category: 'model event'>
 
-        model remove: anEvent item
+        "model remove: anEvent item"
     ]
 
     classRecategorizedEvent: anEvent [
         <category: 'model event'>
 
-        | namespace root toAdd |
+        "| namespace root toAdd |
         namespace := anEvent item environment.
 	(anEvent item category isNil or: [ anEvent item category size = 0 ]) ifTrue: [ ^ self ].
         root := ClassCategory named: anEvent item category into: namespace.
@@ -146,7 +143,7 @@ GtkConcreteWidget subclass: GtkCategorizedNamespaceWidget [
 					toAdd := root.
 					root := root parent ].
 	root parent ifNil: [ root := namespace ].
-	model append: toAdd parent: root
+	model append: toAdd parent: root"
     ]
 ]
 
diff --git a/packages/visualgst/StBrowser/GtkCategoryWidget.st b/packages/visualgst/StBrowser/GtkCategoryWidget.st
index f313b52..adbecce 100644
--- a/packages/visualgst/StBrowser/GtkCategoryWidget.st
+++ b/packages/visualgst/StBrowser/GtkCategoryWidget.st
@@ -33,14 +33,14 @@
 |
 ======================================================================"
 
-GtkConcreteWidget subclass: GtkCategoryWidget [
-    | categoryTree categories model class |
+Compoment subclass: GtkCategoryWidget [
+
+    | categories class |
 
     GtkCategoryWidget >> on: aClass [
 	<category: 'instance creation'>
 
-	^ (self new)
-	    initialize;
+	^ self new
 	    classOrMeta: aClass;
 	    yourself
     ]
@@ -49,7 +49,7 @@ GtkConcreteWidget subclass: GtkCategoryWidget [
 	<category: 'initialization'>
 
 	self initializeCategories.
-	self mainWidget: self buildTreeView.
+	self buildTreeView.
 	self registerNotifier
     ]
 
@@ -77,7 +77,7 @@ GtkConcreteWidget subclass: GtkCategoryWidget [
 
 	class := aClass.
 	categories empty.
-	model
+	widget
 	    item: (self buildCategory: categories);
 	    refresh
     ]
@@ -100,31 +100,27 @@ GtkConcreteWidget subclass: GtkCategoryWidget [
     clear [
         <category: 'accessing'>
 
-        model clear
+        widget clear
     ]
 
     buildTreeView [
         <category: 'user interface'>
     
-	categoryTree := GtkScrollTreeWidget createListWithModel: {{GtkColumnTextType title: 'Method categories'}}.
-	categoryTree treeView getSelection setMode: GTK.Gtk gtkSelectionBrowse.
-	categoryTree connectToWhenPopupMenu: (CategoryMenus on: self).
-        (model := GtkListModel on: categoryTree treeView getModel)
-                                        contentsBlock: [ :each | {each displayString} ].
-	^ categoryTree mainWidget
+	self widget: (List column: {{GtkColumnTextType title: 'Method categories'}} contents: [ :each | {each displayString} ]).
+	widget singleSelection.
+	widget popupMenu: (CategoryMenus on: self).
     ]
 
     unselectAll [
 	<category: 'selection'>
 
-	categoryTree treeView getSelection unselectAll
+	widget unselectAll
     ]
 
     whenSelectionChangedSend: aSelector to: anObject [
 	<category: 'events'>
 
-	categoryTree treeView getSelection
-	    connectSignal: 'changed' to: anObject selector: aSelector
+	widget whenSelectionChangedSend: aSelector to: anObject
     ]
 
     state [
@@ -138,29 +134,20 @@ GtkConcreteWidget subclass: GtkCategoryWidget [
     hasSelectedCategory [
 	<category: 'testing'>
 
-	^ categoryTree treeView hasSelectedItem
+	^ widget hasSelection
     ]
 
     selectedCategory [
 	<category: 'accessing'>
 
 	self hasSelectedCategory ifFalse: [ self error: 'nothing is selected' ].
-	^ categoryTree treeView selection
+	^ widget selection
     ]
 
     selectACategory: aString [
         <category: 'item selection'>
 
-	categoryTree treeView select: aString
-    ]
-
-    findIterInACategory: aString [
-        <category: 'item selection'>
-
-        | result |
-        result := model findIterInACategory: aString.
-        categoryTree treeView scrollToCell: (model gtkModel getPath: result) column: nil useAlign: false rowAlign: 0.5 colAlign: 0.5.
-        ^ result
+	widget select: aString
     ]
 
     viewedCategoryWidget [
@@ -169,37 +156,30 @@ GtkConcreteWidget subclass: GtkCategoryWidget [
 	^ self
     ]
 
-    viewedCategoryModel [
-	<category: 'accessing'>
-
-	^ model
-    ]
-
     removeEmptyCategory [
 	<category: 'update'>
 
 	| set |
 	set := Set new.
 	self buildCategory: set.
-	(categories - set) do: [ :each | 
-			model remove: each.
-			categories remove: each ifAbsent: [] ]
+	(categories - set) do: [ :each | categories remove: each ifAbsent: [] ].
     ]
 
     addEvent: anEvent [
         <category: 'event'>
 
-        (anEvent item methodClass == self classOrMeta and: [ (model hasItem: anEvent item methodCategory) not ]) ifFalse: [ ^ self ].
+        (anEvent item methodClass == self classOrMeta and: [ (categories includes: anEvent item methodCategory) not ]) ifFalse: [ ^ self ].
         categories add: anEvent item methodCategory.
-	model append: anEvent item methodCategory.
-	self removeEmptyCategory
+	self removeEmptyCategory.
+        widget refresh.
     ]
 
     removeEvent: anEvent [
         <category: 'event'>
 
-        (anEvent item methodClass == self classOrMeta and: [ (model hasItem: anEvent item methodCategory) not ]) ifFalse: [ ^ self ].
-	self removeEmptyCategory
+        (anEvent item methodClass == self classOrMeta and: [ (categories includes: anEvent item methodCategory) not ]) ifFalse: [ ^ self ].
+	self removeEmptyCategory.
+        widget refresh
     ]
 ]
 
diff --git a/packages/visualgst/StBrowser/GtkClassBrowserWidget.st b/packages/visualgst/StBrowser/GtkClassBrowserWidget.st
index cc95c40..58ead5b 100644
--- a/packages/visualgst/StBrowser/GtkClassBrowserWidget.st
+++ b/packages/visualgst/StBrowser/GtkClassBrowserWidget.st
@@ -33,7 +33,8 @@
 |
 ======================================================================"
 
-GtkConcreteWidget subclass: GtkClassBrowserWidget [
+Compoment subclass: GtkClassBrowserWidget [
+
     GtkClassBrowserWidget class [ | Undo | ]
 
     | launcher checkCode namespaceWidget classWidget classHierarchyWidget classHierarchyUpdate iCategoryWidget iMethodWidget cCategoryWidget cMethodWidget classAndInstanceSide codeWidget historyStack state |
@@ -66,75 +67,69 @@ GtkConcreteWidget subclass: GtkClassBrowserWidget [
 
     buildBrowser [
 
-	^ GTK.GtkHPaned addAll: {self buildCategoryClassesAndHierarchy. self buildProtocolAndMethod}
+	^ HPaned addAll: {self buildCategoryClassesAndHierarchy. self buildProtocolAndMethod}
     ]
 
     buildCategoryAndClass [
 
-	^ GTK.GtkHPaned addAll: {self buildNamespaceView. self buildClassView}
+	^ HPaned addAll: {self buildNamespaceView. self buildClassView}
     ]
 
     buildClassBrowser [
 
-	^ GTK.GtkHPaned addAll: {self buildClassCategoryView. self buildClassMethodView}
+	^ HPaned addAll: {self buildClassCategoryView. self buildClassMethodView}
     ]
 
     buildInstanceBrowser [
 
-	^ GTK.GtkHPaned addAll: {self buildInstanceCategoryView. self buildInstanceMethodView}
+	^ HPaned addAll: {self buildInstanceCategoryView. self buildInstanceMethodView}
     ]
 
     buildProtocolAndMethod [
 
-	^ classAndInstanceSide := (GTK.GtkNotebook new)
-	    appendPage: self buildInstanceBrowser tabLabel: (GTK.GtkLabel new: 'Instance');
-	    appendPage: self buildClassBrowser tabLabel: (GTK.GtkLabel new: 'Class');
-	    showAll;
-	    setCurrentPage: 0;
-	    connectSignal: 'switch-page' to: self selector: #'classInstanceSwitchOn:page:number:';
+	^ classAndInstanceSide := Notebook new
+	    addPermanentWidget: self buildInstanceBrowser label: 'Instance';
+	    addPermanentWidget: self buildClassBrowser label: 'Class';
+	    currentPage: 0;
+	    "connectSignal: 'switch-page' to: self selector: #'classInstanceSwitchOn:page:number:';"
 	    yourself
     ]
 
     buildCategoryClassesAndHierarchy [
 
-	^ (GTK.GtkNotebook new)
-	    appendPage: self buildCategoryAndClass tabLabel: (GTK.GtkLabel new: 'Class');
-	    appendPage: self buildHierarchy tabLabel: (GTK.GtkLabel new: 'Hierarchy');
-	    showAll;
-	    setCurrentPage: 0;
-	    connectSignal: 'switch-page' to: self selector: #'namespaceHierarchySwitchOn:page:number:';
+	^ Notebook new
+	    addPermanentWidget: self buildCategoryAndClass label: 'Class';
+	    addPermanentWidget: self buildHierarchy label: 'Hierarchy';
+	    currentPage: 0;
+	    "connectSignal: 'switch-page' to: self selector: #'namespaceHierarchySwitchOn:page:number:';"
 	    yourself
     ]
 
     buildNamespaceView [
 	<category: 'user interface'>
 
-	^ (namespaceWidget := self buildWidget: GtkCategorizedNamespaceWidget whenSelectionChangedSend: #onNamespaceChanged)
-	    mainWidget
+	^ namespaceWidget := self buildWidget: GtkCategorizedNamespaceWidget whenSelectionChangedSend: #onNamespaceChanged
     ]
 
     buildClassView [
 	<category: 'user interface'>
 
-	^ (classWidget := self buildWidget: GtkCategorizedClassWidget whenSelectionChangedSend: #onClassChanged)
-	    mainWidget
+	^ classWidget := self buildWidget: GtkCategorizedClassWidget whenSelectionChangedSend: #onClassChanged
     ]
 
     buildCodeView [
 	<category: 'user interface'>
 
-	codeWidget := GtkSourceCodeWidget showAll 
+	^ codeWidget := GtkSourceCodeWidget new
 			parentWindow: self parentWindow;
 			browser: self;
-			yourself.
-    
-	^ codeWidget mainWidget
+			yourself
     ]
 
     buildWidget: aClass whenSelectionChangedSend: aSymbol [
 	<category: 'user interface'>
 
-	^ aClass showAll
+	^ aClass new
                 whenSelectionChangedSend: aSymbol to: self;
                 yourself
     ]
@@ -143,21 +138,18 @@ GtkConcreteWidget subclass: GtkClassBrowserWidget [
 	<category: 'user interface'>
 
 	^ (classHierarchyWidget := self buildWidget: GtkClassHierarchyWidget whenSelectionChangedSend: #onClassHierarchyChanged)
-	    mainWidget
     ]
 
     buildInstanceCategoryView [
         <category: 'user interface'>
 
         ^ (iCategoryWidget := self buildWidget: GtkCategoryWidget whenSelectionChangedSend: #onInstanceSideCategoryChanged)
-	    mainWidget
     ]
 
     buildClassCategoryView [
 	<category: 'user interface'>
 
 	^ (cCategoryWidget := self buildWidget: GtkCategoryWidget whenSelectionChangedSend: #onClassSideCategoryChanged)
-	    mainWidget
     ]
 
     buildClassMethodView [
@@ -165,7 +157,7 @@ GtkConcreteWidget subclass: GtkClassBrowserWidget [
 
 	^ (cMethodWidget := self buildWidget: GtkMethodWidget whenSelectionChangedSend: #onClassSideMethodChanged)
             browser: self;
-	    mainWidget
+            yourself
     ]
 
     buildInstanceMethodView [
@@ -173,17 +165,13 @@ GtkConcreteWidget subclass: GtkClassBrowserWidget [
 
         ^ (iMethodWidget := self buildWidget: GtkMethodWidget whenSelectionChangedSend: #onInstanceSideMethodChanged)
             browser: self;
-	    mainWidget
+            yourself
     ]
 
     buildBrowserPaned [
         <category: 'user interface'>
 
-	^ GTK.GtkVPaned new
-	    pack1: self buildBrowser resize: true shrink: false;
-	    pack2: self buildCodeView resize: true shrink: true ;
-	    showAll;
-	    yourself
+        self widget: (VPaned with: self buildBrowser with: self buildCodeView)
     ]
 
     initializeHistory [
@@ -204,7 +192,7 @@ GtkConcreteWidget subclass: GtkClassBrowserWidget [
 
 	self 
 	    initializeHistory;
-	    mainWidget: self buildBrowserPaned
+	    buildBrowserPaned
     ]
 
     postInitialize [
@@ -229,7 +217,7 @@ GtkConcreteWidget subclass: GtkClassBrowserWidget [
     grabFocus [
 	<category: 'user interface'>
 
-	namespaceWidget mainWidget grabFocus
+	namespaceWidget grabFocus
     ]
 
     namespaceHierarchySwitchOn: aGtkNotebook page: aGtkNotebookPage number: aSmallInteger [
@@ -533,14 +521,14 @@ GtkConcreteWidget subclass: GtkClassBrowserWidget [
         <category: 'selection'>
 
 	self selectClass: aSelector in: iMethodWidget withCategory: iCategoryWidget.
-	classAndInstanceSide setCurrentPage: 0
+	classAndInstanceSide currentPage: 0
     ]
 
     selectAClassMethod: aSelector [
 	<category: 'selection'>
 
 	self selectMetaclass: aSelector in: cMethodWidget withCategory: cCategoryWidget.
-	classAndInstanceSide setCurrentPage: 1
+	classAndInstanceSide currentPage: 1
     ]
 
     targetObject [
diff --git a/packages/visualgst/StBrowser/GtkClassHierarchyWidget.st b/packages/visualgst/StBrowser/GtkClassHierarchyWidget.st
index 272b60a..0bfd6ad 100644
--- a/packages/visualgst/StBrowser/GtkClassHierarchyWidget.st
+++ b/packages/visualgst/StBrowser/GtkClassHierarchyWidget.st
@@ -33,14 +33,14 @@
 |
 ======================================================================"
 
-GtkConcreteWidget subclass: GtkClassHierarchyWidget [
-    | root dic classesTree model classOrMeta |
+Compoment subclass: GtkClassHierarchyWidget [
+
+    | root dic classOrMeta |
 
     GtkClassHierarchyWidget >> on: aClass [
 	<category: 'instance creation'>
 
-	^ (self new)
-	    initialize;
+	^ self new
 	    classOrMeta: aClass;
 	    yourself
     ]
@@ -50,7 +50,7 @@ GtkConcreteWidget subclass: GtkClassHierarchyWidget [
 
 	dic := Dictionary new.
 	self 
-	    mainWidget: self buildTreeView;
+	    buildTreeView;
 	    registerNotifier
     ]
 
@@ -75,17 +75,15 @@ GtkConcreteWidget subclass: GtkClassHierarchyWidget [
 	classOrMeta := aClass asClass.
 	dic := Dictionary new.
 	self buildSuperclasses.
-	model 
-	    item: #root;
-	    refresh.
+	widget refresh.
 	
-	classesTree 
+	widget 
 		expandAll;
 		select: aClass
     ]
 
     emptyModel [
-        classesTree getSelection unselectAll
+        widget unselectAll
     ]
 
     buildSuperclasses [
@@ -101,37 +99,35 @@ GtkConcreteWidget subclass: GtkClassHierarchyWidget [
     buildTreeView [
 	<category: 'user interface'>
    
-        classesTree := GTK.GtkTreeView createTreeWithModel: {{GtkColumnTextType title: 'Classes'}}.
-        classesTree getSelection setMode: GTK.Gtk gtkSelectionBrowse.
-        (model := GtkTreeModel on: classesTree getModel)
-                                        item: #root;
-                                        childrenBlock: [ :each |
-					    dic at: each ifAbsent: [ | col |
+        self widget: (Tree 
+                        column: {{GtkColumnTextType title: 'Classes'}}
+                        children: [ :each |
+				            dic at: each ifAbsent: [ | col |
                                                         col := SortedCollection sortBlock: [ :a :b | a asClass name <= b asClass name ].
 							col addAll: (each subclasses select: [ :behavior | behavior isClass ]).
-                                            col ] ];
-                                        contentsBlock: [ :each | {each asClass name asString, ' '} ].
-        ^ GTK.GtkScrolledWindow withChild: classesTree 
+                                            col ] ]
+                        contents: [ :each | {each asClass name asString, ' '} ]).
+        widget singleSelection.
+        widget item: #root.
     ]
 
     whenSelectionChangedSend: aSelector to: anObject [
 	<category: 'events'>
 
-	classesTree getSelection
-	    connectSignal: 'changed' to: anObject selector: aSelector
+	widget whenSelectionChangedSend: aSelector to: anObject
     ]
 
     hasSelectedClass [
 	<category: 'testing'>
 
-	^ classesTree hasSelectedItem
+	^ widget hasSelection
     ]
 
     selectedClass [
 	<category: 'accessing'>
 
 	self hasSelectedClass ifFalse: [ ^ self classOrMeta " self error: 'Nothing is selected' " ].
-	^ classesTree selection asClass
+	^ widget selection asClass
     ]
 
     state [
diff --git a/packages/visualgst/StBrowser/GtkMethodWidget.st b/packages/visualgst/StBrowser/GtkMethodWidget.st
index 77803a6..d28d6e5 100644
--- a/packages/visualgst/StBrowser/GtkMethodWidget.st
+++ b/packages/visualgst/StBrowser/GtkMethodWidget.st
@@ -33,14 +33,14 @@
 |
 ======================================================================"
 
-GtkConcreteWidget subclass: GtkMethodWidget [
-    | browser model methodTree class category |
+Compoment subclass: GtkMethodWidget [
+
+    | browser class category |
 
     GtkMethodWidget >> on: aClass withCategory: aCategory [
 	<category: 'instance creation'>
 
-	^ (self new)
-	    initialize;
+	^ self new
 	    class: aClass withCategory: aCategory;
 	    yourself
     ]
@@ -49,7 +49,7 @@ GtkConcreteWidget subclass: GtkMethodWidget [
 	<category: 'initialization'>
 
 	self 
-	    mainWidget: self buildTreeView;
+	    buildTreeView;
 	    registerNotifier
     ]
 
@@ -84,9 +84,9 @@ GtkConcreteWidget subclass: GtkMethodWidget [
 
 	category := aString.
 	self classOrMeta methodDictionary ifNil: [ 
-		model clear. 
+		self clear. 
 		^ self].
-	model 
+	widget 
 	    item: ((self classOrMeta methodDictionary select: [ :each | self category = '*' or: [ each methodCategory = self category ] ]) 
 												    asArray sort: [ :a :b | a selector <= b selector ]);
 	    refresh
@@ -105,10 +105,6 @@ GtkConcreteWidget subclass: GtkMethodWidget [
 	self category: aString
     ]
 
-    gtkModel [
-	^ methodTree treeView getModel
-    ]
-
     emptyModel [
         <category: 'accessing'>
 
@@ -118,7 +114,7 @@ GtkConcreteWidget subclass: GtkMethodWidget [
     clear [
         <category: 'accessing'>
 
-	model clear
+	widget clear
     ]
 
     includesCategory: aSymbol [
@@ -132,12 +128,9 @@ GtkConcreteWidget subclass: GtkMethodWidget [
     buildTreeView [
         <category: 'user interface'>
     
-	methodTree := GtkScrollTreeWidget createListWithModel: {{GtkColumnPixbufType visible. GtkColumnTextType title: 'Methods'}}.
-        methodTree connectToWhenPopupMenu: (MethodMenus on: self).
-	methodTree treeView getSelection setMode: GTK.Gtk gtkSelectionBrowse.
-	(model := GtkListModel on: methodTree treeView getModel)
-					contentsBlock: [ :each | {each methodViewIcon. each selector asString} ].
-	^ methodTree mainWidget
+	self widget: (List column: {{GtkColumnPixbufType visible. GtkColumnTextType title: 'Methods'}} contents: [ :each | {each methodViewIcon. each selector asString} ]).
+        widget popupMenu: (MethodMenus on: self).
+	widget singleSelection.
     ]
 
     hasSelectedTestMethod [
@@ -151,8 +144,7 @@ GtkConcreteWidget subclass: GtkMethodWidget [
     whenSelectionChangedSend: aSelector to: anObject [
 	<category: 'events'>
 
-	methodTree treeView getSelection
-	    connectSignal: 'changed' to: anObject selector: aSelector
+	widget whenSelectionChangedSend: aSelector to: anObject
     ]
 
     launcher [
@@ -190,7 +182,7 @@ GtkConcreteWidget subclass: GtkMethodWidget [
     hasSelectedMethod [
 	<category: 'testing'>
 
-	^ methodTree treeView hasSelectedItem
+	^ widget hasSelection
     ]
 
     ifNoSelection: aBlock [
@@ -209,13 +201,13 @@ GtkConcreteWidget subclass: GtkMethodWidget [
 	<category: 'accessing'>
 
 	self ifNoSelection: [ self error: 'nothing is selected' ].
-        ^ methodTree treeView selection 
+        ^ widget selection 
     ]
 
     selectAMethod: aSymbol [
         <category: 'item selection'>
 
-	methodTree treeView select: (self classOrMeta methodDictionary at: aSymbol)
+	widget select: (self classOrMeta methodDictionary at: aSymbol)
     ]
 
     sourceCode [
@@ -236,14 +228,14 @@ GtkConcreteWidget subclass: GtkMethodWidget [
         <category: 'event'>
 
         (anEvent item methodClass == self classOrMeta and: [ self includesCategory: anEvent item methodCategory ] ) ifFalse: [ ^ self ].
-        model append: anEvent item
+        widget refresh
     ]
 
     removeEvent: anEvent [
         <category: 'event'>
 
         (anEvent item methodClass == self classOrMeta and: [ self includesCategory: anEvent item methodCategory ]) ifFalse: [ ^ self ].
-        model remove: anEvent item
+        widget refresh
     ]
 ]
 
diff --git a/packages/visualgst/Tetris/Tetris.st b/packages/visualgst/Tetris/Tetris.st
index 04856fb..9f1348c 100644
--- a/packages/visualgst/Tetris/Tetris.st
+++ b/packages/visualgst/Tetris/Tetris.st
@@ -27,7 +27,7 @@
 |
  ======================================================================"
 
-GtkMainWindow subclass: Tetris [
+Window subclass: Tetris [
     | canvasWidget canvas process pause delay grid movingBlocks level score level lines |
     
     <category: 'Graphics-Tetris'>
diff --git a/packages/visualgst/Widget/Box.st b/packages/visualgst/Widget/Box.st
new file mode 100644
index 0000000..f795899
--- /dev/null
+++ b/packages/visualgst/Widget/Box.st
@@ -0,0 +1,82 @@
+"======================================================================
+|
+| Box class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Widget subclass: Box [
+
+    Box class >> with: aWidget [
+        <category: 'instance creation'>
+
+        ^ self new
+            add: aWidget;
+            yourself
+    ]
+
+    Box class >> with: aWidget1 with: aWidget2 [
+        <category: 'instance creation'>
+
+        ^ self new
+            add: aWidget1;
+            add: aWidget2;
+            yourself
+    ]
+
+    | widgets |
+
+    initialize [
+        <category: 'initialization'>
+
+        child := self box new: false spacing: 3.
+        widgets := OrderedCollection new.
+        super initialize.
+    ]
+
+    add: aWidget [
+        <category: 'accessing'>
+
+        child packStart: (widgets add: aWidget) mainWidget expand: false fill: true padding: 3
+    ]
+
+    add: aWidget expand: aBoolean [
+        <category: 'accessing'>
+
+        child packStart: (widgets add: aWidget) mainWidget expand: aBoolean fill: true padding: 3
+    ]
+
+    box [
+        <category: 'accessing'>
+
+    ]
+]
+
diff --git a/packages/visualgst/Widget/Compoment.st b/packages/visualgst/Widget/Compoment.st
new file mode 100644
index 0000000..752d220
--- /dev/null
+++ b/packages/visualgst/Widget/Compoment.st
@@ -0,0 +1,65 @@
+"======================================================================
+|
+| Compoment class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Widget subclass: Compoment [
+
+    | widget |
+
+    initialize [
+	<category: 'initialization'>
+
+    ]
+
+    widget: aWidget [
+	<category: 'initialization'>
+
+	widget := aWidget.
+        widget parent: self.
+        child := aWidget mainWidget.
+        self showAll.
+    ]
+
+    showAll [
+	<category: 'user interface'>
+
+	child showAll
+    ]
+
+    hideAll [
+	<category: 'user interface'>
+
+	widget hideAll
+    ]
+]
diff --git a/packages/visualgst/Widget/Entry.st b/packages/visualgst/Widget/Entry.st
new file mode 100644
index 0000000..251f46c
--- /dev/null
+++ b/packages/visualgst/Widget/Entry.st
@@ -0,0 +1,67 @@
+"======================================================================
+|
+| Entry class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Widget subclass: Entry [
+
+    initialize [
+        <category: 'initialization'>
+
+        child := GTK.GtkEntry new.
+        super initialize.
+    ]
+
+    completion: anArray [
+
+        | completion model |
+        completion := GTK.GtkEntryCompletion new.
+        completion
+            setModel: (model := GTK.GtkListStore createModelWith: {{GtkColumnTextType title: ''}});
+            setTextColumn: 0.
+        anArray do: [ :each | model appendItem: each ].
+	child setCompletion: completion
+    ]
+
+    text [
+
+	^ child getText
+    ]
+
+    whenTextChangedSend: aSelector to: anObject [
+        <category: 'events'>
+
+        child connectSignal: 'activate' to: anObject selector: aSelector
+    ]
+]
+
